#!/bin/sh

# UpStare is a system that can apply immediate dynamic software updates
# in multi-threaded userspace applications using stack
# reconstruction. It is Copyright (C) 2006 by Kristis Makris
# <kristis.makris@asu.edu,mkgnu@mkgnu.net>.

# In executable binary form produced and digitally signed specifically
# by Kristis Makris, it is freely distributed for personal and
# academic/research use. It is NOT distributed for commercial use. No
# other binary forms can be distributed.

# The source code and documentation, either in electronic or hardcopy
# format, may not be used for any purpose whatsoever without the written
# permission of Kristis Makris.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.


RUNTIME_HEADERS="/usr/include/upstare/runtime"
HCU_DIFF="/usr/bin/hcu_cilly.sh --save-temps --stats -I $RUNTIME_HEADERS"
HCU_SMALL_FILE="/usr/lib/upstare/lib/UpStare/share/tools/hcu_small_file.c"

if [ $# -ne 3 ]; then
    echo "usage: $0 <old_version_filename> <new_version_filename> <yes/no for source code evolution report>"
    exit -1
fi



HCU_OLD_VERSION_FILENAME=$1
HCU_NEW_VERSION_FILENAME=$2
HCU_SOURCE_CODE_EVOLUTION_REPORT=$3

if [ "${HCU_SOURCE_CODE_EVOLUTION_REPORT}" = "yes" ]; then
    HCU_DIFF_REPORT_FLAGS=--source-evolution-report
else
    HCU_DIFF_REPORT_FLAGS=
fi


# First create preprocessed versions of the files that will be parsed
HCU_PREPROCESSED_OLD_VERSION_FILENAME=$HCU_OLD_VERSION_FILENAME.hcudiff.c
HCU_PREPROCESSED_NEW_VERSION_FILENAME=$HCU_NEW_VERSION_FILENAME.hcudiff.c
$HCU_DIFF -E $HCU_OLD_VERSION_FILENAME -o $HCU_PREPROCESSED_OLD_VERSION_FILENAME 
$HCU_DIFF -E $HCU_NEW_VERSION_FILENAME -o $HCU_PREPROCESSED_NEW_VERSION_FILENAME 

# Now diff the preprocessed files
$HCU_DIFF -S --doPatchGeneration --old-version-filename=$HCU_PREPROCESSED_OLD_VERSION_FILENAME --new-version-filename=$HCU_PREPROCESSED_NEW_VERSION_FILENAME $HCU_DIFF_REPORT_FLAGS --no-patch-generation $HCU_SMALL_FILE
